varying vec4	shadow_TexCoord, std_TexCoord, std_detail;
varying vec4 color;
varying vec4 projCoord;
uniform sampler2DShadow	ShadowTex; //Shadow

uniform int ShadowMode;

uniform sampler2D	DetailTex;
uniform sampler2D	NormTex;

void main()
{
	/*vec4 smCoeff =  texture2D(ShadowTex, std_TexCoord.st);

	vec3	shadowScreen_TexCoord	= shadow_TexCoord.xyz / shadow_TexCoord.w;
	float shadowColor		= 0.0;
	float z = shadowScreen_TexCoord.z * 0.98;

	if(texture2D(ShadowTex, shadowScreen_TexCoord.st		).z >= z){shadowColor += 1.0;}

	gl_FragColor = 1*smCoeff;
	*/

	const float kTransparency = 0.3;
	vec4 color = vec4(0.7,0.7,0.7,0.7);

	float rValue = shadow2DProj(ShadowTex, projCoord).r + kTransparency;
	rValue = clamp(rValue, 0.0, 1.0);

	vec3 coordPos  = projCoord.xyz / projCoord.w;

	
	vec4 smCoeff =  texture2D(NormTex, std_TexCoord.st);

	vec4 detail =  texture2D(DetailTex, std_detail.st);

	if (ShadowMode == 0) rValue = 1.0;

//	if (smCoeff.x>0) 



/*z
//PCF
vec3 shadowUV = projCoord.xyz / projCoord.q;
	float mapScale = 1.0 / 512.0;

	vec4 shadowColor = shadow2D(ShadowTex, shadowUV);

	shadowColor += shadow2D(ShadowTex, shadowUV.xyz + vec3( mapScale,  mapScale, 0));
	shadowColor += shadow2D(ShadowTex, shadowUV.xyz + vec3( mapScale, -mapScale, 0));
	shadowColor += shadow2D(ShadowTex, shadowUV.xyz + vec3( mapScale,  	  0, 0));
	shadowColor += shadow2D(ShadowTex, shadowUV.xyz + vec3(-mapScale,  mapScale, 0));
	shadowColor += shadow2D(ShadowTex, shadowUV.xyz + vec3(-mapScale, -mapScale, 0));
	shadowColor += shadow2D(ShadowTex, shadowUV.xyz + vec3(-mapScale,  	  0, 0));
	shadowColor += shadow2D(ShadowTex, shadowUV.xyz + vec3(        0,  mapScale, 0));
	shadowColor += shadow2D(ShadowTex, shadowUV.xyz + vec3(        0, -mapScale, 0));

	shadowColor = shadowColor / 9.0;

	shadowColor += kTransparency;
	shadowColor = clamp(shadowColor, 0.0, 1.0);

*/


	 //calculate fog attenuation
   float fogAtten = 1.0 - (gl_Fog.end - gl_FogFragCoord) * gl_Fog.scale;
   fogAtten = clamp(fogAtten, 0.0, 1.0);

		gl_FragColor = mix(clamp(smCoeff*rValue+detail-0.5, 0.0, 1.0), gl_Fog.color, fogAtten); //clamp(smCoeff*rValue+detail-0.5, 0.0, 1.0); // color * rValue;
}