varying vec4	shadow_TexCoord, std_TexCoord, std_detail;
varying vec4 color;
varying vec4 projCoord;
uniform mat4	mTextureMatrix;
//uniform mat4    mCameraViewMatrix;

void main()
{
	vec4 realPos = gl_ModelViewMatrix * gl_Vertex;
  
	std_TexCoord = gl_MultiTexCoord0;
	std_detail = gl_MultiTexCoord1;

	projCoord = mTextureMatrix * realPos;
	gl_FrontColor = gl_Color;

	gl_Position = ftransform(); 
	gl_FogFragCoord = gl_Position.z;
}
